=== debian/changelog ===
mcrl2 (201001+svn7611-1) unstable; urgency=low

  * New SVN snapshot upload:
    - Features renaming of sim and xsim to lpssim and lpsxsim 
      (closes: #573944).
    - Features renaming of grape to grapemcrl2 (closes: #573943).
    - Fixes documentation/examples install issue.
  * debian/control:
    - Changed build-depends to build against Boost 1.42.
      Closes: #573844, #577289.
  * debian/rules:
    - Removed documentation directory mkdir/mv/rmdir commands from the
      install target now that this is fixed upstream.
  * debian/source/format: Switched to source format 3.0 (quilt). 

 -- Paul van Tilburg <paulvt@debian.org>  Sun, 11 Apr 2010 17:18:35 +0200

mcrl2 (201001-1) unstable; urgency=low

  * Initial release (Closes: #460885).
  * Use a pruned upstream tarball to avoid (a lot of) source duplication by
    removing 3rd-party/boost.

 -- Paul van Tilburg <paulvt@debian.org>  Tue, 16 Feb 2010 12:50:42 +0200
